package com.rebusland.fin.derivatives.eq.server.input.model;

import org.joda.beans.ImmutableBean;
import org.joda.beans.gen.BeanDefinition;

import com.rebusland.fin.derivatives.eq.server.common.model.SerializableBeanFacade;
import java.util.Map;
import java.util.NoSuchElementException;
import org.joda.beans.Bean;
import org.joda.beans.JodaBeanUtils;
import org.joda.beans.MetaBean;
import org.joda.beans.MetaProperty;
import org.joda.beans.gen.PropertyDefinition;
import org.joda.beans.impl.direct.DirectFieldsBeanBuilder;
import org.joda.beans.impl.direct.DirectMetaBean;
import org.joda.beans.impl.direct.DirectMetaProperty;
import org.joda.beans.impl.direct.DirectMetaPropertyMap;

@BeanDefinition
public class FlatMarketData extends SerializableBeanFacade implements ImmutableBean {
	@PropertyDefinition(validate = "notNull")
	private final Double rfRate;

	@PropertyDefinition(validate = "notNull")
	private final Double volatility;

	//------------------------- AUTOGENERATED START -------------------------
	/**
	 * The meta-bean for {@code FlatMarketData}.
	 * @return the meta-bean, not null
	 */
	public static FlatMarketData.Meta meta() {
		return FlatMarketData.Meta.INSTANCE;
	}

	static {
		MetaBean.register(FlatMarketData.Meta.INSTANCE);
	}

	/**
	 * Returns a builder used to create an instance of the bean.
	 * @return the builder, not null
	 */
	public static FlatMarketData.Builder builder() {
		return new FlatMarketData.Builder();
	}

	/**
	 * Restricted constructor.
	 * @param builder  the builder to copy from, not null
	 */
	protected FlatMarketData(FlatMarketData.Builder builder) {
		JodaBeanUtils.notNull(builder.rfRate, "rfRate");
		JodaBeanUtils.notNull(builder.volatility, "volatility");
		this.rfRate = builder.rfRate;
		this.volatility = builder.volatility;
	}

	@Override
	public FlatMarketData.Meta metaBean() {
		return FlatMarketData.Meta.INSTANCE;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the rfRate.
	 * @return the value of the property, not null
	 */
	public Double getRfRate() {
		return rfRate;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the volatility.
	 * @return the value of the property, not null
	 */
	public Double getVolatility() {
		return volatility;
	}

	//-----------------------------------------------------------------------
	/**
	 * Returns a builder that allows this bean to be mutated.
	 * @return the mutable builder, not null
	 */
	public Builder toBuilder() {
		return new Builder(this);
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == this) {
			return true;
		}
		if (obj != null && obj.getClass() == this.getClass()) {
			FlatMarketData other = (FlatMarketData) obj;
			return JodaBeanUtils.equal(rfRate, other.rfRate) &&
					JodaBeanUtils.equal(volatility, other.volatility);
		}
		return false;
	}

	@Override
	public int hashCode() {
		int hash = getClass().hashCode();
		hash = hash * 31 + JodaBeanUtils.hashCode(rfRate);
		hash = hash * 31 + JodaBeanUtils.hashCode(volatility);
		return hash;
	}

	@Override
	public String toString() {
		StringBuilder buf = new StringBuilder(96);
		buf.append("FlatMarketData{");
		int len = buf.length();
		toString(buf);
		if (buf.length() > len) {
			buf.setLength(buf.length() - 2);
		}
		buf.append('}');
		return buf.toString();
	}

	protected void toString(StringBuilder buf) {
		buf.append("rfRate").append('=').append(JodaBeanUtils.toString(rfRate)).append(',').append(' ');
		buf.append("volatility").append('=').append(JodaBeanUtils.toString(volatility)).append(',').append(' ');
	}

	//-----------------------------------------------------------------------
	/**
	 * The meta-bean for {@code FlatMarketData}.
	 */
	public static class Meta extends DirectMetaBean {
		/**
		 * The singleton instance of the meta-bean.
		 */
		static final Meta INSTANCE = new Meta();

		/**
		 * The meta-property for the {@code rfRate} property.
		 */
		private final MetaProperty<Double> rfRate = DirectMetaProperty.ofImmutable(
				this, "rfRate", FlatMarketData.class, Double.class);
		/**
		 * The meta-property for the {@code volatility} property.
		 */
		private final MetaProperty<Double> volatility = DirectMetaProperty.ofImmutable(
				this, "volatility", FlatMarketData.class, Double.class);
		/**
		 * The meta-properties.
		 */
		private final Map<String, MetaProperty<?>> metaPropertyMap$ = new DirectMetaPropertyMap(
				this, null,
				"rfRate",
				"volatility");

		/**
		 * Restricted constructor.
		 */
		protected Meta() {
		}

		@Override
		protected MetaProperty<?> metaPropertyGet(String propertyName) {
			switch (propertyName.hashCode()) {
				case -934505164:  // rfRate
					return rfRate;
				case -1917967323:  // volatility
					return volatility;
			}
			return super.metaPropertyGet(propertyName);
		}

		@Override
		public FlatMarketData.Builder builder() {
			return new FlatMarketData.Builder();
		}

		@Override
		public Class<? extends FlatMarketData> beanType() {
			return FlatMarketData.class;
		}

		@Override
		public Map<String, MetaProperty<?>> metaPropertyMap() {
			return metaPropertyMap$;
		}

		//-----------------------------------------------------------------------
		/**
		 * The meta-property for the {@code rfRate} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<Double> rfRate() {
			return rfRate;
		}

		/**
		 * The meta-property for the {@code volatility} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<Double> volatility() {
			return volatility;
		}

		//-----------------------------------------------------------------------
		@Override
		protected Object propertyGet(Bean bean, String propertyName, boolean quiet) {
			switch (propertyName.hashCode()) {
				case -934505164:  // rfRate
					return ((FlatMarketData) bean).getRfRate();
				case -1917967323:  // volatility
					return ((FlatMarketData) bean).getVolatility();
			}
			return super.propertyGet(bean, propertyName, quiet);
		}

		@Override
		protected void propertySet(Bean bean, String propertyName, Object newValue, boolean quiet) {
			metaProperty(propertyName);
			if (quiet) {
				return;
			}
			throw new UnsupportedOperationException("Property cannot be written: " + propertyName);
		}

	}

	//-----------------------------------------------------------------------
	/**
	 * The bean-builder for {@code FlatMarketData}.
	 */
	public static class Builder extends DirectFieldsBeanBuilder<FlatMarketData> {

		private Double rfRate;
		private Double volatility;

		/**
		 * Restricted constructor.
		 */
		protected Builder() {
		}

		/**
		 * Restricted copy constructor.
		 * @param beanToCopy  the bean to copy from, not null
		 */
		protected Builder(FlatMarketData beanToCopy) {
			this.rfRate = beanToCopy.getRfRate();
			this.volatility = beanToCopy.getVolatility();
		}

		//-----------------------------------------------------------------------
		@Override
		public Object get(String propertyName) {
			switch (propertyName.hashCode()) {
				case -934505164:  // rfRate
					return rfRate;
				case -1917967323:  // volatility
					return volatility;
				default:
					throw new NoSuchElementException("Unknown property: " + propertyName);
			}
		}

		@Override
		public Builder set(String propertyName, Object newValue) {
			switch (propertyName.hashCode()) {
				case -934505164:  // rfRate
					this.rfRate = (Double) newValue;
					break;
				case -1917967323:  // volatility
					this.volatility = (Double) newValue;
					break;
				default:
					throw new NoSuchElementException("Unknown property: " + propertyName);
			}
			return this;
		}

		@Override
		public Builder set(MetaProperty<?> property, Object value) {
			super.set(property, value);
			return this;
		}

		@Override
		public FlatMarketData build() {
			return new FlatMarketData(this);
		}

		//-----------------------------------------------------------------------
		/**
		 * Sets the rfRate.
		 * @param rfRate  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder rfRate(Double rfRate) {
			JodaBeanUtils.notNull(rfRate, "rfRate");
			this.rfRate = rfRate;
			return this;
		}

		/**
		 * Sets the volatility.
		 * @param volatility  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder volatility(Double volatility) {
			JodaBeanUtils.notNull(volatility, "volatility");
			this.volatility = volatility;
			return this;
		}

		//-----------------------------------------------------------------------
		@Override
		public String toString() {
			StringBuilder buf = new StringBuilder(96);
			buf.append("FlatMarketData.Builder{");
			int len = buf.length();
			toString(buf);
			if (buf.length() > len) {
				buf.setLength(buf.length() - 2);
			}
			buf.append('}');
			return buf.toString();
		}

		protected void toString(StringBuilder buf) {
			buf.append("rfRate").append('=').append(JodaBeanUtils.toString(rfRate)).append(',').append(' ');
			buf.append("volatility").append('=').append(JodaBeanUtils.toString(volatility)).append(',').append(' ');
		}

	}

	//-------------------------- AUTOGENERATED END --------------------------
}
